﻿#pragma once

#include "..\..\DuiLib\UIlib.h"
#include "DuiDefine.h"
#include "SearchWndList.h"

#define MSG_CLOSE_MAIN_SEARCH (WM_USER + 9930)

class MainFrame;

class CSearchWnd : public WindowImplBase
{
    DUI_DECLARE_MESSAGE_MAP()
    DUI_DECLARE_CUSTOM_MSG_MAP()
public:
	CSearchWnd(HWND hWnd, CRect rc);
	~CSearchWnd();

	LPCTSTR GetWindowClassName() const;
	void InitWindow();
	void OnPrepare(TNotifyUI& msg);
	void UpdateFriendsList();
	void SetClientRect(CRect rc);
	
	CSearchWndList* GetFriendsCtrl();
	NTIPTStatusType GetMemberIPTStatus(LPCWSTR strUserID);
	void MakeIPTMenu( NTIPTStatusType iptMyStatus, NTIPTStatusType iptStatusOfBuddy, const NE_MEMBER_DATA* pMembereData, CMenu* pPopup );
	void OnMenuIPT(const NE_MEMBER_DATA* pMembereData, WPARAM wParam);
	void CallToIPT(NE_MEMBER_DATA userData, CString strTel);
	void EnableCloseWindow(BOOL bEnable);
	BOOL IsEnableClose();

	virtual CDuiString GetSkinFile();
	virtual CDuiString GetSkinFolder();
	virtual void OnFinalMessage(HWND hWnd);
	virtual CControlUI* CreateControl(LPCTSTR pstrClass);

    //WindowImplBase
    virtual LRESULT OnKeyDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	virtual LRESULT OnKillFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	virtual LRESULT OnNcHitTest(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    virtual LRESULT OnSize(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
public:
	std::vector<SearchWndItemInfo> m_vecfriend;
	BOOL m_bEnableClose;

private:
	CRect m_rcClient;
	SearchWndItemInfo m_friendListInfo;
	
    void _OnCtrlOrgBtnIPTClick(TNotifyUI& msg);
    void _OnCtrlFavoriteClick(TNotifyUI& msg);
    void _OnCtrlElementUIDbClick(TNotifyUI& msg);
    void _OnCtrlElementUIItemClick(TNotifyUI& msg);
};
